unit untInputOutput;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, SolarCalendarPackage, NumberToStr;

type
  TfrmInputOutput = class(TForm)
    grpBody: TGroupBox;
    lblAcountID: TLabel;
    edtAcountID: TEdit;
    btnFind: TBitBtn;
    pnlHint: TPanel;
    edtType: TEdit;
    grpInfo: TGroupBox;
    lblNameFamily: TLabel;
    lblFathername: TLabel;
    lblShID: TLabel;
    lblBDate: TLabel;
    lblAddress: TLabel;
    lblSupply: TLabel;
    edtNameFamily: TEdit;
    edtFathername: TEdit;
    edtShID: TEdit;
    edtBDate: TEdit;
    edtAddress: TEdit;
    edtSupply: TEdit;
    grpTools: TGroupBox;
    lblAccountType: TLabel;
    edtAccountType: TEdit;
    btnOk: TBitBtn;
    lblMablaq: TLabel;
    edtMablaq: TEdit;
    lblDate: TLabel;
    edtDate: TSolarDatePicker;
    btnCancel: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure edtMablaqChange(Sender: TObject);
    procedure edtAcountIDKeyPress(Sender: TObject; var Key: Char);
    procedure edtDateKeyPress(Sender: TObject; var Key: Char);
    procedure edtMablaqKeyPress(Sender: TObject; var Key: Char);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInputOutput: TfrmInputOutput;

implementation

uses untDataModule;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.FormShow(Sender: TObject);
begin
  edtAcountID.Clear;
   edtMablaq.Clear;
    edtDate.Clear;
     edtNameFamily.Clear;
    edtFathername.Clear;
   edtShID.Clear;
   edtBDate.Clear;
    edtAccountType.Clear;
     edtAddress.Clear;
    edtSupply.Clear;
   grpBody.Enabled := False;
  edtAcountID.SetFocus;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.btnCancelClick(Sender: TObject);
begin
  frmInputOutput.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.btnFindClick(Sender: TObject);
var
  sSQL: string;
begin
 if Length(edtAcountID.Text) > 0 then
   begin
     sSQL := 'SELECT NameFamily, Fathername, ShID, BDate, AccountType, Address';
     sSQL := sSQL + ', Supply FROM tblAccount WHERE AccountID = :PAccountID';

     frmDataModule.DBQuery.Close;
     frmDataModule.DBQuery.SQL.Clear;
     frmDataModule.DBQuery.SQL.Add(sSQL);
     frmDataModule.DBQuery.Parameters.ParamByName('PAccountID').Value := 
       edtAcountID.Text;
     frmDataModule.DBQuery.ExecSQL;
     frmDataModule.DBQuery.Open;

     if frmDataModule.DBQuery.RecordCount > 0 then
       begin
         edtNameFamily.Text := frmDataModule.DBQuery.FieldByName(
           'NameFamily').AsString;
         edtFathername.Text := frmDataModule.DBQuery.FieldByName(
           'Fathername').AsString;
         edtShID.Text := frmDataModule.DBQuery.FieldByName(
           'ShID').AsString;
         edtBDate.Text := frmDataModule.DBQuery.FieldByName(
           'BDate').AsString;
         edtAccountType.Text := frmDataModule.DBQuery.FieldByName(
           'AccountType').AsString;
         edtAddress.Text := frmDataModule.DBQuery.FieldByName(
           'Address').AsString;
         edtSupply.Text := Set3Digit(frmDataModule.DBQuery.FieldByName(
           'Supply').AsString);
         grpBody.Enabled := True;
         edtMablaq.SetFocus;
       end
     else
       begin
         MsDlg('  ', '      ', mtError, [
           mbOk], ['']);
         FormShow(Sender);
       end;
   end
 else
   begin
     MsDlg('  ', '      ', mtError, [
       mbOk], ['']);
     edtAcountID.SetFocus;
   end;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.edtMablaqChange(Sender: TObject);
begin
  _3Digit(edtMablaq, edtMablaqChange);
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.edtAcountIDKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end
 else if not(Key in ['0'..'9', #8]) then
   Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.edtDateKeyPress(Sender: TObject; var Key: Char);
begin
 Key := #0;
 Perform(WM_NEXTDLGCTL, 0, 0);
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.edtMablaqKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputOutput.btnOkClick(Sender: TObject);
var
 sSQL: string;
 CReman, TempSupply: LongInt;
begin
 if(Length(edtMablaq.Text) > 0)and(Length(edtDate.Text) > 0)then
   begin
     if edtType.Text = '1' then
       begin
         TempSupply := StrToInt(GetNumber(edtMablaq.Text));

         sSQL := 'SELECT Supply FROM tblAccount WHERE AccountID = :ParamAID';
         frmDataModule.DBQuery.Close;
         frmDataModule.DBQuery.SQL.Clear;
         frmDataModule.DBQuery.SQL.Add(sSQL);
         frmDataModule.DBQuery.Parameters.ParamByName('ParamAID').Value :=
           edtAcountID.Text;
         frmDataModule.DBQuery.ExecSQL;
         frmDataModule.DBQuery.Open;
         CReman := frmDataModule.DBQuery.FieldByName(
           'Supply').AsInteger;

         CReman := CReman + TempSupply;

         sSQL := 'UPDATE tblAccount SET Supply='+
                 IntToStr(CReman) +' WHERE AccountID = :ParamAID';
         frmDataModule.DBSCommand.CommandText := sSQL;
         frmDataModule.DBSCommand.Parameters.ParamByName('ParamAID').Value :=
           edtAcountID.Text;
         frmDataModule.DBSCommand.Execute;

         sSQL := 'SELECT Reman FROM tblSandoq';
         frmDataModule.DBQuery.Close;
         frmDataModule.DBQuery.SQL.Clear;
         frmDataModule.DBQuery.SQL.Add(sSQL);
         frmDataModule.DBQuery.ExecSQL;
         frmDataModule.DBQuery.Open;
         CReman := frmDataModule.DBQuery.FieldByName(
           'Reman').AsInteger;

         CReman := CReman + TempSupply;

         sSQL := 'UPDATE tblSandoq SET Reman=' + IntToStr(CReman);
         frmDataModule.DBSCommand.CommandText := sSQL;
         frmDataModule.DBSCommand.Execute;

         MsDlg('  ', '    ', mtInformation, [
           mbOk], ['']);
         frmInputOutput.Close;
       end
     else if edtType.Text = '2' then
       begin
         TempSupply := StrToInt(GetNumber(edtMablaq.Text));

         sSQL := 'SELECT Supply FROM tblAccount WHERE AccountID = :ParamAID';
         frmDataModule.DBQuery.Close;
         frmDataModule.DBQuery.SQL.Clear;
         frmDataModule.DBQuery.SQL.Add(sSQL);
         frmDataModule.DBQuery.Parameters.ParamByName('ParamAID').Value :=
           edtAcountID.Text;
         frmDataModule.DBQuery.ExecSQL;
         frmDataModule.DBQuery.Open;
         CReman := frmDataModule.DBQuery.FieldByName(
           'Supply').AsInteger;

         if TempSupply <= CReman then
           begin
             CReman := CReman - TempSupply;

             sSQL := 'UPDATE tblAccount SET Supply='+
                 IntToStr(CReman) +' WHERE AccountID = :ParamAID';
             frmDataModule.DBSCommand.CommandText := sSQL;
              frmDataModule.DBSCommand.Parameters.ParamByName('ParamAID').Value :=
               edtAcountID.Text;
             frmDataModule.DBSCommand.Execute;

            sSQL := 'SELECT Reman FROM tblSandoq';
            frmDataModule.DBQuery.Close;
             frmDataModule.DBQuery.SQL.Clear;
             frmDataModule.DBQuery.SQL.Add(sSQL);
             frmDataModule.DBQuery.ExecSQL;
            frmDataModule.DBQuery.Open;
            CReman := frmDataModule.DBQuery.FieldByName(
               'Reman').AsInteger;

             CReman := CReman - TempSupply;

             sSQL := 'UPDATE tblSandoq SET Reman=' + IntToStr(CReman);
             frmDataModule.DBSCommand.CommandText := sSQL;
             frmDataModule.DBSCommand.Execute;

            MsDlg('  ', '    ', 
              mtInformation, [mbOk], ['']);
             frmInputOutput.Close;
           end
         else
           begin
             MsDlg('  ', '       ' +
               '', mtError, [mbOk], ['']);
             edtMablaq.Clear;
             edtMablaq.SetFocus;
           end;
       end;
   end
 else
   begin
     MsDlg('  ', '       ', 
       mtError, [mbOk], ['']);
     edtMablaq.SetFocus;  
   end;
end;
//*******************************TortriX Software*******************************
end.
